﻿using UnityEngine;
#if UNITY_EDITOR // Editorフォルダに格納するか#if UNITY_EDITORで囲まないとビルド時エラーとなる
using UnityEditor;
#endif

/**
 * オリジナルインスペクタのプロパティ属性。
 */
public class CustomAttribute : PropertyAttribute {
	/**
	 * 数値。
	 */
	public int value;

	/**
	 * 最小/最大の値。
	 */
	public int min;
	public int max;

	/**
	 * コンストラクタ。
	 */
	public CustomAttribute(int min, int max) {
		this.min = min;
		this.max = max;		
	}
}

#if UNITY_EDITOR
/**
 * オリジナルインスペクタの描画。
 */
[CustomPropertyDrawer(typeof(CustomAttribute))]
public class CustomDrawer : PropertyDrawer {
	/**
	 * OnGUI.
	 */
	public override void OnGUI(Rect position, SerializedProperty property, GUIContent label) {
		CustomAttribute customAttr = (CustomAttribute)attribute;

		Debug.Log(property.name + " : " + property.intValue);

		EditorGUI.IntSlider(position, property, customAttr.min, customAttr.max);
	}
}
#endif